From 0e3ee8e398ebd17e0b68768c7587ac5cfd56d126 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 02 2020 07:51:41 +0000
Subject: [PATCH 1220/2232] Implement forward declaration for enums


---

diff --git a/gen/src/write.rs b/gen/src/write.rs
index 9d07173..ebef728 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -31,7 +31,7 @@ pub(super) fn gen(apis: &[Api], types: &Types, opt: &Opt, header: bool) -> Vec<u
 
 fn write_forward_declarations(out: &mut OutFile, apis: &[Api]) {
     let needs_forward_declaration = |api: &&Api| match api {
-        Api::Struct(_) | Api::CxxType(_) | Api::RustType(_) => true,
+        Api::Struct(_) | Api::Enum(_) | Api::CxxType(_) | Api::RustType(_) => true,
         _ => false,
     };
 
@@ -47,6 +47,7 @@ fn write_forward_declarations(out: &mut OutFile, apis: &[Api]) {
             write!(out, "{:1$}", "", indent);
             match api {
                 Api::Struct(strct) => write_struct_decl(out, &strct.ident.cxx.ident),
+                Api::Enum(enm) => write_enum_decl(out, enm),
                 Api::CxxType(ety) => write_struct_using(out, &ety.ident.cxx),
                 Api::RustType(ety) => write_struct_decl(out, &ety.ident.cxx.ident),
                 _ => unreachable!(),
@@ -207,6 +208,12 @@ fn write_struct_decl(out: &mut OutFile, ident: &Ident) {
     writeln!(out, "struct {};", ident);
 }
 
+fn write_enum_decl(out: &mut OutFile, enm: &Enum) {
+    write!(out, "enum class {} : ", enm.ident.cxx.ident);
+    write_atom(out, enm.repr);
+    writeln!(out, ";");
+}
+
 fn write_struct_using(out: &mut OutFile, ident: &CppName) {
     writeln!(
         out,

